#!/bin/sh
#poor mans xdg jwm menu generator by goingnuts for pupngo 210211

#structure in desktop-files
#[Desktop Entry]
#Encoding=UTF-8
#Name=Abiword wordprocessor
#Icon=abiword_16.xpm
#Comment=Abiword wordprocessor
#Exec=abiword
#Terminal=false
#Type=Application
#Categories=WordProcessor
#GenericName=Abiword wordprocessor

#structure for jwm categories
#<Menu label="Desktop" icon="x24.png" height="16">
#structure for jwm menus
#<Program label="Configure Xlock screen locking" icon="lock-screen48.png">/usr/local/apps/Xlock/AppRun -configure</Program>

#overall categories
MAINCATEGORIES="AudioVideo
Development
Education
Game
Graphics
Help
Network
Office
Settings
System
Utility"
#dummy category="Other"

FILES=$(ls /usr/share/applications/*.desktop)
echo -n "" > /tmp/menu
for X in ${FILES}; do
  NAME=$(cat "${X}" | grep ^Name= | cut -d "=" -f 2)	#get the application name
  ICON=$(cat "${X}" | grep ^Icon= | cut -d "=" -f 2)	#get the icon
  if [ "${ICON}" = "" ]; then	#set default icon
    ICON="Default.png"
  fi
  COMMAND=$(cat "${X}" | grep ^Exec= | cut -d "=" -f 2)	#get the command
  CATEGORY=$(cat "${X}" | grep ^Categories= | cut -d "=" -f 2)	#get the category
  #check to which category it belongs
  if [ ! "${CATEGORY}" = "" ]; then
    if [ ! "$(echo $MAINCATEGORIES | grep $CATEGORY)" = "" ]; then
      for Y in ${MAINCATEGORIES}; do
        if [ "${Y}" = "${CATEGORY}" ]; then
          echo "<Program label=\"$NAME\" icon=\"$ICON\">$COMMAND</Program>" >> /tmp/"${CATEGORY}"
        fi
      done
    else
       echo "<Program label=\"$NAME\" icon=\"$ICON\">$COMMAND</Program>" >> /tmp/Other
    fi
  fi
done

#now construct the final menu
echo -n "" > /tmp/menu
#handle the Other category
if [ -f /tmp/Other ]; then
  echo "<Menu label=\"Other\" icon=\"Other.png\">" >> /tmp/menu
  cat /tmp/Other >> /tmp/menu
  echo "</Menu>" >> /tmp/menu
fi
for Y in ${MAINCATEGORIES}; do
  if [ -f /tmp/$Y ]; then
    echo "<Menu label=\"$Y\" icon=\"$Y.png\">" >> /tmp/menu
    cat /tmp/$Y >> /tmp/menu
    echo "</Menu>" >> /tmp/menu
  fi
done

#publish the menu
echo "<JWM>" > /root/.jwmrc-installed
cat /tmp/menu >> /root/.jwmrc-installed
echo "</JWM>" >> /root/.jwmrc-installed
#clean up
for Y in ${MAINCATEGORIES}; do
  rm -f /tmp/$Y
done
rm -f /tmp/Other
rm -f /tmp/menu

exit